#include "servo.h"
#include "gpio.h"
#include "timer1.h"
#include "usart.h"
#include <avr/interrupt.h>

static bool smoking = false;

/* Handler Intrerupere Receive USART0 */
ISR(USART0_RX_vect)
{
	char recv = USART0_receive();

	if (recv == 's' && !smoking) {
		smoking = true;

		PUMP_start();
		
		LED_set();

		TIMER1_start();

		USART0_print("Smoke on!!!\n");
	}

	if (recv == 'o') {
		SERVO_open();
	}

	if (recv == 'c') {
		SERVO_close();
	}
}

/* Handler timer1 pentru terminarea timpului */
ISR(TIMER1_COMPA_vect)
{
	smoking = false;

	/* LED-uri */
	LED_clear();

	/* Pompa */
	PUMP_stop();

	USART0_print("Smoke off...\n");

	TIMER1_stop();
}

int main(void)
{
	/* Initializari */
	PUMP_init();
	BUT_init();
	LED_init();
	SERVO_init();
	TIMER1_init();
	USART0_init();

	/* Activare intreruperi */
	sei();

	while(1);
}
