#include "servo.h"
#include "usart.h"
#include <avr/io.h>
#include <util/delay.h>

#define SERVO_MIN 10
#define SERVO_MAX 38

void SERVO_init(void)
{
	/* Pini servo */
	DDRB |= (1 << PB3);
	DDRB |= (1 << PB4);

	/* ----PWM---- */

	/* Clear on compare / set on bottom */
	TCCR0A |= (1 << COM0A1);
	TCCR0A |= (1 << COM0B1);

	/* Mod: fast pwm cu top la 0xFF (pe 8 biti) */
	TCCR0A |= (3 << WGM00);

	/* Prescaler: 1024 */
	TCCR0B |= (5 << CS00);

	OCR0A = SERVO_MIN;
	OCR0B = SERVO_MAX;
}

void SERVO_open(void)
{
	if (OCR0A < SERVO_MAX && OCR0B > SERVO_MIN)
		USART0_print("Opening wings!!\n");
	else
		USART0_print("Already opened!!!\n");

	for (; OCR0A < SERVO_MAX; OCR0A++) {
		OCR0B--;
		_delay_ms(20);
	}
}

void SERVO_close(void)
{
	if (OCR0A > SERVO_MIN && OCR0B < SERVO_MAX)
		USART0_print("Closing wings!!\n");
	else
		USART0_print("Already closed!!!\n");

	for (; OCR0A > SERVO_MIN; OCR0A--) {
		OCR0B++;
		_delay_ms(20);
	}
}
