#include "timer1.h"
#include <avr/io.h>

void TIMER1_init(void)
{
	/* Mod: CTC cu top la OCR1A */
	TCCR1B |= (1 << WGM12);

	/* Activare intrerupere la compare cu OCR1A */
	TIMSK1 |= (1 << OCIE1A);

	OCR1A = 0xA000;
}

void TIMER1_start(void)
{
	/* Prescaler: 1024 */
	TCCR1B |= (5 << CS10);
}

void TIMER1_stop(void)
{
	/* Prescaler: 0 / TCNT: 0 */
	TCCR1B &= ~(7 << CS10);
	TCNT1H = 0;
	TCNT1L = 0;
}
